DROP PROCEDURE ESTOQUE^
CREATE PROCEDURE ESTOQUE(
VCODIGO INTEGER, 
VLOJA INTEGER, 
VDATA CHAR(12)
)
AS
DECLARE VARIABLE     VANTERIOR NUMERIC(15,2);
DECLARE VARIABLE     VENTRADA NUMERIC(15,2);
DECLARE VARIABLE     VSAIDA NUMERIC(15,2);
DECLARE VARIABLE     VPERDA NUMERIC(15,2);
DECLARE VARIABLE     VTRANSFE NUMERIC(15,2);
DECLARE VARIABLE     VTRANSFS NUMERIC(15,2);
DECLARE VARIABLE     VDEVOLE NUMERIC(15,2);
DECLARE VARIABLE     VDEVOLS NUMERIC(15,2);
DECLARE VARIABLE     VACERTOE NUMERIC(15,2);
DECLARE VARIABLE     VACERTOS NUMERIC(15,2);
DECLARE VARIABLE     VESTOQUE NUMERIC(15,2);
DECLARE VARIABLE     VULTENT DATE;
DECLARE VARIABLE     VQTDENT NUMERIC(15,2);
DECLARE VARIABLE     VESTDAT NUMERIC(15,2);
DECLARE VARIABLE     VULTSAI DATE;
DECLARE VARIABLE     VULTPER DATE;
DECLARE VARIABLE     VULTTRE DATE;
DECLARE VARIABLE     VULTTRS DATE;
DECLARE VARIABLE     VULTDVE DATE;
DECLARE VARIABLE     VULTDVS DATE;
DECLARE VARIABLE     VULTACE DATE;
DECLARE VARIABLE     VULTACS DATE; 
DECLARE VARIABLE     YSAIDA NUMERIC(15,2);
DECLARE VARIABLE     YPERDA NUMERIC(15,2);
DECLARE VARIABLE     YTRANSFE NUMERIC(15,2);
DECLARE VARIABLE     YTRANSFS NUMERIC(15,2);
DECLARE VARIABLE     YDEVOLE NUMERIC(15,2);
DECLARE VARIABLE     YDEVOLS NUMERIC(15,2);
DECLARE VARIABLE     YACERTOE NUMERIC(15,2);
DECLARE VARIABLE     YACERTOS NUMERIC(15,2);
BEGIN
  SELECT SUM(QUANT) FROM ITENS_ENTRADA WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND DATA>=:VDATA INTO :VENTRADA;
  SELECT SUM(I.QUANT) FROM RESUMO R JOIN ITENSNOTA I ON R.NNOTA=I.NNOTA AND R.LOJA=I.LOJA AND R.DATA=I.DATA AND
         R.OPERACAO='1' AND I.CODIGO=:VCODIGO AND I.LOJA=:VLOJA AND I.DATA>=:VDATA INTO :VSAIDA;
  SELECT SUM(QUANT) FROM PERDAS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND DATA>=:VDATA INTO :VPERDA;
  SELECT SUM(QUANT) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND DESTINO=:VLOJA AND DATA>=:VDATA AND CALCULAENTRADA='S' INTO :VTRANSFE;
  SELECT SUM(QUANT) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND ORIGEM=:VLOJA AND DATA>=:VDATA INTO :VTRANSFS;
  SELECT SUM(QUANT) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='C' AND DATA>=:VDATA INTO :VDEVOLE;
  SELECT SUM(QUANT) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='F' AND DATA>=:VDATA INTO :VDEVOLS;
  SELECT SUM(QUANT) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='E' AND DATA>=:VDATA INTO :VACERTOE;
  SELECT SUM(QUANT) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='S' AND DATA>=:VDATA INTO :VACERTOS;
  SELECT SUM(ANTERIOR) FROM LOCAIS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA INTO :VANTERIOR;
  FOR
    SELECT MAX(DATA) FROM ITENS_ENTRADA WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA INTO :VULTENT
  DO
  FOR
    SELECT MAX(DATA) FROM ITENSNOTA WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA INTO :VULTSAI
  DO
  FOR
    SELECT MAX(DATA) FROM PERDAS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA INTO :VULTPER
  DO
  FOR
    SELECT MAX(DATA) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND DESTINO=:VLOJA INTO :VULTTRE
  DO
  FOR
    SELECT MAX(DATA) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND ORIGEM=:VLOJA INTO :VULTTRS
  DO
  FOR
    SELECT MAX(DATA) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='C' INTO :VULTDVE
  DO
  FOR
    SELECT MAX(DATA) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='F' INTO :VULTDVS
  DO
  FOR
    SELECT MAX(DATA) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='E' INTO :VULTACE
  DO
  FOR
    SELECT MAX(DATA) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='S' INTO :VULTACS
  DO
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM ITENS_ENTRADA WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND DATA=:VULTENT INTO :VQTDENT;

  IF (VULTENT > '1900/01/01') THEN SELECT SUM(I.QUANT) FROM RESUMO R JOIN ITENSNOTA I ON R.NNOTA=I.NNOTA AND R.LOJA=I.LOJA AND R.DATA=I.DATA AND
                                          R.OPERACAO='1' AND I.CODIGO=:VCODIGO AND I.LOJA=:VLOJA AND I.DATA>=:VDATA INTO :YSAIDA;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM PERDAS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND DATA>=:VULTENT INTO :YPERDA;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND DESTINO=:VLOJA AND DATA>=:VULTENT AND CALCULAENTRADA='S' INTO :YTRANSFE;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM TRANSFERENCIAS WHERE CODIGO=:VCODIGO AND ORIGEM=:VLOJA AND DATA>=:VULTENT INTO :YTRANSFS;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='C' AND DATA>=:VULTENT INTO :YDEVOLE;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM DEVOLUCOES WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='F' AND DATA>=:VULTENT INTO :YDEVOLS;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='E' AND DATA>=:VULTENT INTO :YACERTOE;
  IF (VULTENT > '1900/01/01') THEN SELECT SUM(QUANT) FROM ACERTOS WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA AND TIPO='S' AND DATA>=:VULTENT INTO :YACERTOS;
  IF (VANTERIOR is null) THEN VANTERIOR = 0;
  IF (VENTRADA is null) THEN VENTRADA = 0;
  IF (VSAIDA is null) THEN VSAIDA = 0;
  IF (VPERDA is null) THEN VPERDA = 0;
  IF (VTRANSFE is null) THEN VTRANSFE = 0;
  IF (VTRANSFS is null) THEN VTRANSFS = 0;
  IF (VDEVOLE is null) THEN VDEVOLE = 0;
  IF (VDEVOLS is null) THEN VDEVOLS = 0;
  IF (VACERTOE is null) THEN VACERTOE = 0;
  IF (VACERTOS is null) THEN VACERTOS = 0;
  VESTOQUE = (VANTERIOR+VENTRADA-VSAIDA-VPERDA+VTRANSFE-VTRANSFS+VDEVOLE-VDEVOLS+VACERTOE-VACERTOS);
  IF (YSAIDA is null) THEN YSAIDA = 0;
  IF (YPERDA is null) THEN YPERDA = 0;
  IF (YTRANSFE is null) THEN YTRANSFE = 0;
  IF (YTRANSFS is null) THEN YTRANSFS = 0;
  IF (YDEVOLE is null) THEN YDEVOLE = 0;
  IF (YDEVOLS is null) THEN YDEVOLS = 0;
  IF (YACERTOE is null) THEN YACERTOE = 0;
  IF (YACERTOS is null) THEN YACERTOS = 0;
  VESTDAT = (VESTOQUE-VQTDENT+YSAIDA+YPERDA-YTRANSFE+YTRANSFS-YDEVOLE+YDEVOLS-YACERTOE+YACERTOS);
  UPDATE LOCAIS SET 
    ANTERIOR = :VANTERIOR,
    ENTRADA = :VENTRADA,
    SAIDA = :VSAIDA,
    PERDA = :VPERDA,
    TRANSFE = :VTRANSFE,
    TRANSFS = :VTRANSFS,
    DEVOLE = :VDEVOLE,
    DEVOLS = :VDEVOLS,
    ACERTOE = :VACERTOE,
    ACERTOS = :VACERTOS,
    ESTOQUE = :VESTOQUE,
    ULTENT = :VULTENT,
    ULTSAI = :VULTSAI,
    ULTPER = :VULTPER,
    ULTTRFS = :VULTTRS,
    ULTTRFE = :VULTTRE,
    ULTDEVS = :VULTDVS,
    ULTDEVE = :VULTDVE,
    ULTACES = :VULTACS,
    ULTACEE = :VULTACE,
    QTENTRA = :VQTDENT,
    ESTDATA = :VESTDAT WHERE CODIGO=:VCODIGO AND LOJA=:VLOJA;
  SUSPEND;
END;^
drop trigger grava_pagtonull_rec^
create trigger grava_pagtonull_rec
for receber
active
before insert or update
position 0
as
begin
  if (new.PAGTO = '1899/12/31') then begin
    new.PAGTO = null;
  end
end;^
drop trigger grava_pagtonull_pag^
create trigger grava_pagtonull_pag
for pagar
active
before insert or update
position 0
as
begin
  if (new.PAGTO = '1899/12/31') then begin
    new.PAGTO = null;
  end
end;^